<?
//	FPDF simple example used on www.rockarocky.fr.st
//	File Name: fpdf_example.php
//	Version: 0.1
//	Date : 23/April/2002
//	Author : Franck Del-Rey
//	Info: For PHP4, version FPDF v1.41
//	Licence : Freeware, You modify the way you want that piece of code
//	Special -> :( For Trash English

//	For More informations on FPDF see :
//	Official Site -> http://www.fpdf.org
//	English FAQ   -> http://www.fpdf.org/en/FAQ.php
//	FAQ Francaise -> http://www.fpdf.org/fr/FAQ.php
//	Author : Olivier PLATHEY

// FPDF path
define('FPDF_FONTPATH','../fpdf/font/');
require('../fpdf/fpdf.php');

// ================================
// Lazy Define For Cell & Multicell
// ================================
// Bold
define('BOLD', 'B');
// Italic
define('ITALIC', 'I');
// Align Right
define('RIGHT', 'R');
// Align Left
define('LEFT', 'L');
// Align Center
define('CENTER', 'C');
// Continue to Right line
define('GOTO_RIGHT_LINE', 0);
// Make a New line
define('GOTO_NEW_LINE', 1);
// No border
define('NO_BORDER', 0);
// Border
define('BORDER', 1);
// No fill Cell
define('NO_FILL', 0);
// Fill Cell
define('FILL', 1);


// Start - Definition Child class
class PDF extends FPDF
{
// RockaRocky document update
var $rar_update;
// How many concerts in the list
var $rar_nconcerts;

// Page Header
function Header()
	{
	// Update Info & site publicity at right
	// Police style and size
	$this->SetFont('Arial',BOLD,9);
	// Text Color
	$this->SetTextColor(0,0,0);
	$this->Cell(0,4,'Update '.$this->rar_update.' www.rockarocky.fr.st',NO_BORDER,GOTO_RIGHT_LINE,RIGHT);
	// Jump 10 lines
	$this->Ln(10);
	}

// Page Footer
function Footer()
	{
	// Position -1,5 cm start on bottom
	$this->SetY(-15);
	// Police style and size
	$this->SetFont('Arial',BOLD.ITALIC,8);
	// Page Number
	$this->cell(0,10,'Page '.$this->PageNo().'/{PAGES}',NO_BORDER,GOTO_RIGHT_LINE,CENTER);
	}

// Document Title
function Title()
	{
	// Jump 2 lines
	$this->Ln(2);
	// =======================
	// FPDF Logo, text and url
	// =======================
	$this->Cell(0,4,'Created with FPDF free PDF library',NO_BORDER,GOTO_NEW_LINE,LEFT);
	$this->Cell(0,4,'www.fpdf.org',NO_BORDER,GOTO_NEW_LINE,LEFT);
	$this->Image('fpdf_logo.png',10,7,22);
	// Eddy Cochran
	$this->Image('eddy.png',25,90,15);
	// ================
	// Rockarocky title
	// ================
	// Rockarocky title file with the location path
	define('FILE_TITLE', 'rockarocky_logo.txt');
	// Little test if file exist
	if (!file_exists(FILE_TITLE))
		die('Error opening file '.FILE_TITLE);
	$f=@fopen(FILE_TITLE,'r');
	$text_title=fread($f,filesize(FILE_TITLE));
	fclose($f);
	// Police style and size
	$this->SetFont('courier',BOLD,11);
	// Text color
	$this->SetTextColor(255,0,0);
	// Text in Multi Cell
	$this->MultiCell(0,5,$text_title,NO_BORDER,CENTER);
	// Line Jump
	$this->Ln();
	// =============================
	// How many concerts in the list
	// =============================
	// Push to right
	$this->Cell(60);
	// Background color
	$this->SetFillColor(128,128,128);
	// Text color
	$this->SetTextColor(255,255,255);
	$this->Cell(70,8,'>>> '.$this->rar_nconcerts.' Concerts <<<',NO_BORDER,GOTO_RIGHT_LINE,CENTER,FILL);
	// Jump 16 lines
	$this->Ln(16);
	}
}
// End - Definition Child class

// Concert File with the location path
define('FILE_CONCERT', 'dates_concerts.txt');
// Little test if file exist
if (!file_exists(FILE_CONCERT))
	die('Error opening file '.FILE_CONCERT);
$fcontents = file(FILE_CONCERT);

// Start : Deal between Rocky And Me
// =================================
// My Array index
define('INDEX_WHEN',  0);
define('INDEX_WHERE', 1);
define('INDEX_WHO',   2);
define('INDEX_WHAT',  3);
// URL & Email things
define('URL_EMAIL_THINGS', "\[([^]]+)(-)([^]]+)\]");
// Clean what I don't want
$fcontents=str_replace("\"", '', $fcontents);
$fcontents=str_replace(";", " ", $fcontents);
// My index $i
$i=0;
while (list($line_num, $line) = each($fcontents))
	{
	// Separate Field
	$fields = explode("\t",$line);
	// We want WHEN, WHERE and WHO
	if (($fields[INDEX_WHEN]  == NULL) ||
		($fields[INDEX_WHERE] == NULL) ||
		($fields[INDEX_WHO]   == NULL))
		continue;
	// WHEN
	// ====
	$fields[INDEX_WHEN]=str_replace("*", '', $fields[INDEX_WHEN]);
	$fields[INDEX_WHEN]=str_replace("+", '', $fields[INDEX_WHEN]);
	$fields[INDEX_WHEN]=str_replace("", '', $fields[INDEX_WHEN]);
	$CBG_MAP[$i]['WHEN']=trim($fields[INDEX_WHEN]);
	// WHERE
	// =====
	while (ereg(URL_EMAIL_THINGS,$fields[INDEX_WHERE]))
		$fields[INDEX_WHERE]=ereg_replace(URL_EMAIL_THINGS, "[\\1######\\3]", $fields[INDEX_WHERE]);
	$fields[INDEX_WHERE]=ereg_replace(" *- *", " , ", $fields[INDEX_WHERE]);
	$fields[INDEX_WHERE]=str_replace("######", "-",   $fields[INDEX_WHERE]);
	$fields[INDEX_WHERE]=ereg_replace("\[|\]", " ",   $fields[INDEX_WHERE]);
	$fields[INDEX_WHERE]=ereg_replace("  +", " ",     $fields[INDEX_WHERE]);
	$CBG_MAP[$i]['WHERE']=trim($fields[INDEX_WHERE]);
	// WHO
	// ===
	while (ereg(URL_EMAIL_THINGS,$fields[INDEX_WHO]))
		$fields[INDEX_WHO]=ereg_replace(URL_EMAIL_THINGS, "[\\1######\\3]", $fields[INDEX_WHO]);
	$fields[INDEX_WHO]=ereg_replace(" *- *", "\n",  $fields[INDEX_WHO]);
	$fields[INDEX_WHO]=str_replace("######", "-",   $fields[INDEX_WHO]);
	$fields[INDEX_WHO]=ereg_replace("\[|\]", " ",   $fields[INDEX_WHO]);
	$fields[INDEX_WHO]=ereg_replace(" *\n *", "\n", $fields[INDEX_WHO]);
	$fields[INDEX_WHO]=ereg_replace("  +", " ",     $fields[INDEX_WHO]);
	$CBG_MAP[$i]['WHO']=trim($fields[INDEX_WHO]);
	// WHAT
	// ====
	$fields[INDEX_WHAT]=ereg_replace(" *- *", " / ", $fields[INDEX_WHAT]);
	$fields[INDEX_WHAT]=ereg_replace(" *, *", " / ", $fields[INDEX_WHAT]);
	$fields[INDEX_WHAT]=ereg_replace("  +", " ",     $fields[INDEX_WHAT]);
	$CBG_MAP[$i]['WHAT']=trim($fields[INDEX_WHAT]);
	$i++;
	}
// End : Deal between Rocky And Me
// ===============================

// Start to Create My PDF
$pdf=new PDF();
$pdf->Open();
// RockaRocky Update
$pdf->rar_update=date('d/m/Y');
// How many concerts
$pdf->rar_nconcerts=count($CBG_MAP);
// AliasNbPages Only on Version 1.4 or superior
$pdf->AliasNbPages('{PAGES}');
$pdf->AddPage();
$pdf->SetAuthor('www.rockarocky.fr.st');
// Call document, page title
$pdf->Title();

// Start to write data in my PDF
// =============================
// My Cells height
define('CELL_HEIGHT', 4);

// Police style and size
$pdf->SetFont('Helvetica','',8);

foreach($CBG_MAP as $value)
	{
	// it's ok, we have WHEN, WHERE and WHO (other way)
	if (!(($value['WHEN'] != NULL) && ($value['WHERE'] != NULL) && ($value['WHO'] != NULL)))
		continue;

	// What !!! That test !!! The life is hard (Steal in FPDF Class for page Jump)
	if ($pdf->y+(CELL_HEIGHT*4)>$pdf->PageBreakTrigger and $pdf->AutoPageBreak and !$pdf->InFooter)
		$pdf->AddPage();

	// The Date (WHEN) and if the style exist (WHAT)
	$pdf->SetTextColor(255,255,255);
	$pdf->SetFont('',BOLD);
	$pdf->Cell(45,CELL_HEIGHT,$value['WHEN'],NO_BORDER,($value['WHAT']?GOTO_RIGHT_LINE:GOTO_NEW_LINE),CENTER,FILL);
	if ($value['WHAT'] != NULL)
		{
		// Push to right
		$pdf->Cell(5);
		$pdf->SetFont('',ITALIC.BOLD);
		$pdf->SetTextColor(200,0,0);
		$pdf->Cell(0,CELL_HEIGHT,$value['WHAT'],NO_BORDER,GOTO_NEW_LINE);
		}

	$pdf->SetTextColor(0,0,0);
	$pdf->SetFont('','');
	// Adress of the concert place (WHERE)
	$pdf->Cell(-1); // Push to left, Comment this line and see the difference
	$pdf->MultiCell(0,CELL_HEIGHT,$value['WHERE'],NO_BORDER,LEFT);
	$pdf->SetFont('', BOLD);
	// The Band(s) (WHO)
	$pdf->Cell(-1); // Push to left the return
	$pdf->MultiCell(0,CELL_HEIGHT,$value['WHO'],NO_BORDER,LEFT);
	}

// Final
// =====
// My Output File name
$FILE_OUTPUT=strtolower('rockarocky_'.str_replace("/", "_", $pdf->rar_update).'.pdf');

// Type Of Output
define('_PDF_BROWSER', 0);     // On Browser
define('_PDF_DOWNLOAD', 1);    // File Download
define('_PDF_SAVE', 2);        // File save
unset($pdf_output);
$pdf_output['save']=_PDF_SAVE;
$pdf_output['download']=_PDF_DOWNLOAD;
$pdf_output['browser']=_PDF_BROWSER;

switch ($pdf_output[$_GET['pdf_output']])
	{
	// On Browser
	case _PDF_BROWSER :
	default :
		$pdf->Output('',false);
		break;
	// Download the File, possible don't work correctly, IE Make Things
	case _PDF_DOWNLOAD :
		$pdf->Output($FILE_OUTPUT,true);
		break;
	// Save in File
	case _PDF_SAVE :
		$pdf->Output($FILE_OUTPUT,false);
		header('location:'.$_SERVER['HTTP_REFERER']);
		break;
	}

// Bye Bye
?>